#include "utils.h"

/*create a new list with the mother file descriptor (and no bro connection)*/
BP_LinkedListFDBC_t * newFDBClist(int fdConn)
{
  BP_LinkedListFDBC_t * r = calloc(1, sizeof(BP_LinkedListFDBC_t));
  if (!r)
  {
    fprintf(stderr, "not enough memory for fdbc list\n");
    exit(-1);
  }
  r->fd = fdConn;
  return r;
}

/*add a connection in the linked list*/
void addFDBClist(BP_LinkedListFDBC_t * fdList, int fd, BroConn *bc)
{
  BP_LinkedListFDBC_t * current = fdList;
  BP_LinkedListFDBC_t * r = calloc(1, sizeof(BP_LinkedListFDBC_t));

  if (!r)
  {
    fprintf(stderr, "not enough memory for fdbc list\n");
    exit(-1);
  }
  r->fd = fd;
  r->bc = bc;

  while (current->next)
  {
    current = current->next;
  }

  current->next = r;
}

/*cleans an element from a linked list*/
static void cleanFDBCelement(BP_LinkedListFDBC_t * toRemove)
{
  if (toRemove->bc)
  {
    bro_conn_delete(toRemove->bc);
  }
  else
  {
    close(toRemove->fd);
  }
  free(toRemove);
}

/*remove a connection from the linked list*/
void removeFDBClist(BP_LinkedListFDBC_t * fdList, BP_LinkedListFDBC_t * toRemove)
{
  BP_LinkedListFDBC_t * current = fdList;

  while (current)
  {
    if (current->next == toRemove)
    {
      current->next = toRemove->next;
      cleanFDBCelement(toRemove);
      return;
    }
    current = current->next;
  }
}

/*cleans the whole linked list*/
void cleanFDBClist(BP_LinkedListFDBC_t * fdList)
{
  BP_LinkedListFDBC_t * current = fdList;
  BP_LinkedListFDBC_t * next = fdList;

  while (current)
  {
    next = current->next;
    cleanFDBCelement(current);
    current = next;
  }
}
